//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%46F408D2006A.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%46F408D2006A.cm

//## begin module%46F408D2006A.cp preserve=no
//## end module%46F408D2006A.cp

//## Module: OGIPTableReadAll%46F408D2006A; Package specification
//## Subsystem: XSModel::Model::Component::OGIPTable%3D2EE58E0084
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Model/Component/OGIPTable/OGIPTableReadAll.h

#ifndef OGIPTABLEREADALL_H
#define OGIPTABLEREADALL_H 1

//## begin module%46F408D2006A.additionalIncludes preserve=no
//## end module%46F408D2006A.additionalIncludes

//## begin module%46F408D2006A.includes preserve=yes
//## end module%46F408D2006A.includes

// TableAccess
#include <XSModel/Model/Component/OGIPTable/TableAccess.h>
//## begin module%46F408D2006A.declarations preserve=no
//## end module%46F408D2006A.declarations

//## begin module%46F408D2006A.additionalDeclarations preserve=yes
//## end module%46F408D2006A.additionalDeclarations


//## begin OGIPTableReadAll%46F44629038A.preface preserve=yes
//## end OGIPTableReadAll%46F44629038A.preface

//## Class: OGIPTableReadAll%46F44629038A
//## Category: XSModel::Model::Component::OGIPTable%3D2EE54A03A6
//## Subsystem: XSModel::Model::Component::OGIPTable%3D2EE58E0084
//## Persistence: Transient
//## Cardinality/Multiplicity: n



class OGIPTableReadAll : public TableAccess  //## Inherits: <unnamed>%46F4463F016B
{
  //## begin OGIPTableReadAll%46F44629038A.initialDeclarations preserve=yes
  //## end OGIPTableReadAll%46F44629038A.initialDeclarations

  public:
    //## Constructors (generated)
      OGIPTableReadAll();

    //## Destructor (generated)
      virtual ~OGIPTableReadAll();


    //## Other Operations (specified)
      //## Operation: clone%46F7CA4B027B
      virtual OGIPTableReadAll* clone ();

      //## Operation: initialRead%46F7CA800296
      virtual void initialRead (CCfits::ExtHDU& spectraExt, const size_t nEngs, const size_t nAddPars, const bool isSameAsPrev);

      //## Operation: initialAccessRows%46F7CAA501A0
      virtual void initialAccessRows (const IntegerArray& rowNumbers, const size_t nAddPars);

      //## Operation: getSpectrumEntries%46F7CAA5021A
      virtual void getSpectrumEntries (const size_t iEng, Real* values);

      //## Operation: getVarianceEntries%46F7CAA5029B
      virtual void getVarianceEntries (const size_t iEng, Real* values);

      //## Operation: getAddSpectra%46F7CAA50318
      virtual void getAddSpectra (const size_t iEng, const size_t iAdd, Real* values);

      //## Operation: getAddVariance%46F7CAA50399
      virtual void getAddVariance (const size_t iEng, const size_t iAdd, Real* values);

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: isError%46F7DB390089
      virtual bool isError () const;

      //## Attribute: isAddParamError%46F7F2AB035C
      virtual const BoolArray& isAddParamError () const;

      //## Attribute: tableVals%46FA9F7B0008
      const TableValues& tableVals () const;
      void tableVals (const TableValues& value);

    // Additional Public Declarations
      //## begin OGIPTableReadAll%46F44629038A.public preserve=yes
      //## end OGIPTableReadAll%46F44629038A.public

  protected:
    // Additional Protected Declarations
      //## begin OGIPTableReadAll%46F44629038A.protected preserve=yes
      //## end OGIPTableReadAll%46F44629038A.protected

  private:
    //## Constructors (generated)
      OGIPTableReadAll(const OGIPTableReadAll &right);

    //## Assignment Operation (generated)
      OGIPTableReadAll & operator=(const OGIPTableReadAll &right);

    // Additional Private Declarations
      //## begin OGIPTableReadAll%46F44629038A.private preserve=yes
      //## end OGIPTableReadAll%46F44629038A.private

  private: //## implementation
    // Data Members for Class Attributes

      //## Attribute: selectedRows%46F8172D034C
      //## begin OGIPTableReadAll::selectedRows%46F8172D034C.attr preserve=no  private: IntegerArray {U} 
      IntegerArray m_selectedRows;
      //## end OGIPTableReadAll::selectedRows%46F8172D034C.attr

      //## begin OGIPTableReadAll::isError%46F7DB390089.attr preserve=no  public: bool {U} 
      bool m_isError;
      //## end OGIPTableReadAll::isError%46F7DB390089.attr

      //## begin OGIPTableReadAll::isAddParamError%46F7F2AB035C.attr preserve=no  public: BoolArray {U} 
      BoolArray m_isAddParamError;
      //## end OGIPTableReadAll::isAddParamError%46F7F2AB035C.attr

      //## begin OGIPTableReadAll::tableVals%46FA9F7B0008.attr preserve=no  public: TableValues {U} 
      TableValues m_tableVals;
      //## end OGIPTableReadAll::tableVals%46FA9F7B0008.attr

      //## Attribute: prevTable%46FAA7BA0293
      //## begin OGIPTableReadAll::prevTable%46FAA7BA0293.attr preserve=no  private: static TableValues {U} 
      static TableValues s_prevTable;
      //## end OGIPTableReadAll::prevTable%46FAA7BA0293.attr

    // Additional Implementation Declarations
      //## begin OGIPTableReadAll%46F44629038A.implementation preserve=yes
      //## end OGIPTableReadAll%46F44629038A.implementation

};

//## begin OGIPTableReadAll%46F44629038A.postscript preserve=yes
//## end OGIPTableReadAll%46F44629038A.postscript

// Class OGIPTableReadAll 

//## Get and Set Operations for Class Attributes (inline)

inline bool OGIPTableReadAll::isError () const
{
  //## begin OGIPTableReadAll::isError%46F7DB390089.get preserve=no
  return m_isError;
  //## end OGIPTableReadAll::isError%46F7DB390089.get
}

inline const BoolArray& OGIPTableReadAll::isAddParamError () const
{
  //## begin OGIPTableReadAll::isAddParamError%46F7F2AB035C.get preserve=no
  return m_isAddParamError;
  //## end OGIPTableReadAll::isAddParamError%46F7F2AB035C.get
}

inline const TableValues& OGIPTableReadAll::tableVals () const
{
  //## begin OGIPTableReadAll::tableVals%46FA9F7B0008.get preserve=no
  return m_tableVals;
  //## end OGIPTableReadAll::tableVals%46FA9F7B0008.get
}

inline void OGIPTableReadAll::tableVals (const TableValues& value)
{
  //## begin OGIPTableReadAll::tableVals%46FA9F7B0008.set preserve=no
  m_tableVals = value;
  //## end OGIPTableReadAll::tableVals%46FA9F7B0008.set
}

//## begin module%46F408D2006A.epilog preserve=yes
//## end module%46F408D2006A.epilog


#endif
